%define anolis_release 3

Name:		sgml-common
Version:	0.6.3
Release:	%{anolis_release}%{?dist}
Summary:	Common SGML catalog and DTD files

License:	GPL+
URL:		https://www.w3.org/2003/entities/
Source0:	https://www.sourceware.org/pub/docbook-tools/new-trials/SOURCES/sgml-common-0.6.3.tgz
Source1:	xml.dcl
Source2: 	xml.soc
Source3: 	html.dcl
Source4: 	html.soc
Source5: 	http://www.w3.org/%{xmlxsdver}/xml.xsd
Source6: 	http://www.w3.org/TR/xmldsig-core/xmldsig-core-schema.xsd
Source7: 	http://www.w3.org/2001/XMLSchema.dtd
Source8: 	http://www.w3.org/2001/datatypes.dtd
Source9: 	sgmlwhich.1
Source10: 	sgml.conf.5

Patch0: 	0000-sgml-common-umask.patch
Patch1: 	0001-sgml-common-xmldir.patch
Patch2: 	0002-sgml-common-quotes.patch

BuildArch:	noarch

BuildRequires: 	make automake
BuildRequires:  libxml2

Requires: 	%{_bindir}/basename

%description
The sgml-common package contains a collection of entities and DTDs
that are useful for processing SGML, but that don't need to be
included in multiple packages.  Sgml-common also includes an
up-to-date Open Catalog file.

%package -n xml-common
Summary: 		Common XML catalog and DTD files
License: 		GPL+
Requires(pre): 	%{_bindir}/xmlcatalog
 
%description -n xml-common
The xml-common is a subpackage of sgml-common which contains
a collection XML catalogs that are useful for processing XML,
but that don't need to be included in main package.

%package 		doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1 -n %{name}-%{version}

# replace bogus links with files
automakedir=`ls -1d /usr/share/automake* | head -n +1`
for file in COPYING INSTALL install-sh missing mkinstalldirs; do
   rm $file
   cp -p $automakedir/$file .
done

%build
%configure

%install
%make_install htmldir='%{_datadir}/doc'
mkdir $RPM_BUILD_ROOT%{_sysconfdir}/xml
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/sgml/docbook
mkdir -p $RPM_BUILD_ROOT%{_datadir}/sgml/docbook
# Touch SGML catalog
touch $RPM_BUILD_ROOT%{_sysconfdir}/sgml/catalog
# Create an empty XML catalog.
XMLCATALOG=$RPM_BUILD_ROOT%{_sysconfdir}/xml/catalog
%{_bindir}/xmlcatalog --noout --create $XMLCATALOG
# ...and add xml.xsd in it
for type in system uri ; do
	for path in 2001 %{xmlxsdver} ; do
		%{_bindir}/xmlcatalog --noout --add $type \
			"http://www.w3.org/$path/xml.xsd" \
			"file://%{_datadir}/xml/xml.xsd" $XMLCATALOG
	done
	# Add xmldsig-core-schema.xsd to catalog
	%{_bindir}/xmlcatalog --noout --add $type \
		"http://www.w3.org/TR/xmldsig-core/xmldsig-core-schema.xsd" \
		"file://%{_datadir}/xml/xmldsig-core-schema.xsd" $XMLCATALOG
done
# Now put the common DocBook entries in it
for xml_orig in "-//OASIS//ENTITIES DocBook XML" "-//OASIS//DTD DocBook XML" "ISO 8879:1986" ; do
%{_bindir}/xmlcatalog --noout --add "delegatePublic" \
	"$xml_orig" \
	"file://%{_sysconfdir}/sgml/docbook/xmlcatalog" $XMLCATALOG
done
for xml_type in "delegateSystem" "delegateURI" ; do
	%{_bindir}/xmlcatalog --noout --add "$xml_type" \
		"http://www.oasis-open.org/docbook/" \
		"file://%{_sysconfdir}/sgml/docbook/xmlcatalog" $XMLCATALOG
done
for public in "-//W3C//DTD XMLSchema 200102//EN" "-//W3C//DTD XMLSCHEMA 200102//EN" ; do
	%{_bindir}/xmlcatalog --noout --add "public" \
		"$public" \
		"file://%{_datadir}/xml/XMLSchema.dtd" $XMLCATALOG
done
%{_bindir}/xmlcatalog --noout --add "system" \
	"http://www.w3.org/2001/XMLSchema.dtd" \
	"file://%{_datadir}/xml/XMLSchema.dtd" $XMLCATALOG
 
# Also create the common DocBook catalog
%{_bindir}/xmlcatalog --noout --create \
	$RPM_BUILD_ROOT%{_sysconfdir}/sgml/docbook/xmlcatalog
ln -sf %{_sysconfdir}/sgml/docbook/xmlcatalog\
	$RPM_BUILD_ROOT%{_datadir}/sgml/docbook/xmlcatalog
 
rm -f $RPM_BUILD_ROOT%{_datadir}/sgml/xml.dcl
install -m 0644 -p %{SOURCE1} %{SOURCE2} %{SOURCE3} %{SOURCE4} \
	$RPM_BUILD_ROOT%{_datadir}/sgml
rm -rf $RPM_BUILD_ROOT%{_datadir}/xml/*
install -m 0644 -p %{SOURCE5} %{SOURCE6} %{SOURCE7} %{SOURCE8} \
	$RPM_BUILD_ROOT%{_datadir}/xml
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man1
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man5
install -m 0644 -p %{SOURCE9} $RPM_BUILD_ROOT%{_mandir}/man1
install -m 0644 -p %{SOURCE10} $RPM_BUILD_ROOT%{_mandir}/man5
 
# remove installed doc file and prepare installation with %%doc
rm $RPM_BUILD_ROOT%{_datadir}/doc/*.html
rm -rf __dist_doc/html/
mkdir -p __dist_doc/html/
install -m 0644 -p doc/HTML/fdl.html __dist_doc/html/fdl.html
install -m 0644 -p doc/HTML/index.html __dist_doc/html/index.html
install -m 0644 -p doc/HTML/install-catalog.html __dist_doc/html/install-catalog.html
install -m 0644 -p doc/HTML/introduction.html __dist_doc/html/introduction.html

%generate_compatibility_deps

%pre -n xml-common
if [ $1 -gt 1 ] && [ -e %{_sysconfdir}/xml/catalog ]; then
	for type in system uri ; do
		for path in 2001 %{xmlxsdver} ; do
			%{_bindir}/xmlcatalog --noout --add $type \
				"http://www.w3.org/$path/xml.xsd" \
				"file://%{_datadir}/xml/xml.xsd" \
				%{_sysconfdir}/xml/catalog
		done
		%{_bindir}/xmlcatalog --noout --add $type \
			"http://www.w3.org/TR/xmldsig-core/xmldsig-core-schema.xsd" \
			"file://%{_datadir}/xml/xmldsig-core-schema.xsd" %{_sysconfdir}/xml/catalog
	done
	for public in "-//W3C//DTD XMLSchema 200102//EN" "-//W3C//DTD XMLSCHEMA 200102//EN" ; do
		%{_bindir}/xmlcatalog --noout --add "public" \
			"$public" \
			"file://%{_datadir}/xml/XMLSchema.dtd" %{_sysconfdir}/xml/catalog
	done
fi

%files
%dir %{abidir}
%license COPYING
%doc __dist_doc/html/
%dir %{_sysconfdir}/sgml
%config(noreplace) %{_sysconfdir}/sgml/sgml.conf
%ghost %verify(not md5 size mtime) %config(noreplace,missingok) %{_sysconfdir}/sgml/catalog
%{_bindir}/install-catalog
%{_bindir}/sgmlwhich
%{abidir}/install-catalog-option.list
%{abidir}/sgmlwhich-option.list
%dir %{_datadir}/sgml
%dir %{_datadir}/sgml/sgml-iso-entities-8879.1986
%{_datadir}/sgml/sgml-iso-entities-8879.1986/*
%{_datadir}/sgml/xml.dcl
%{_datadir}/sgml/xml.soc
%{_datadir}/sgml/html.dcl
%{_datadir}/sgml/html.soc
%{_mandir}/man8/install-catalog.8*
%{_mandir}/man1/sgmlwhich.1*
%{_mandir}/man5/sgml.conf.5*

%files -n xml-common
%license COPYING
%dir %{_sysconfdir}/xml
%dir %{_sysconfdir}/sgml
%dir %{_sysconfdir}/sgml/docbook
%config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xml/catalog
%config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/sgml/docbook/xmlcatalog
%dir %{_datadir}/sgml
%dir %{_datadir}/sgml/docbook
%{_datadir}/sgml/docbook/xmlcatalog
%dir %{_datadir}/xml
%{_datadir}/xml/xml.xsd
%{_datadir}/xml/xmldsig-core-schema.xsd
%{_datadir}/xml/XMLSchema.dtd
%{_datadir}/xml/datatypes.dtd

%files doc
%doc AUTHORS NEWS ChangeLog README

%changelog
* Thu Apr 13 2023 Guyu Wang <guyu.wgy@linux.alibaba.com> - 0.6.3-3
- Optimise spec file

* Mon Oct 10 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 0.6.3-2
- add doc package

* Mon Apr 18 2022 happy_orange <songnannan@linux.alibaba.com> - 0.6.3-1
- init from upstream
